Panda3D

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
LwoPolygonTags Class Reference

An association of polygons defined in the most recent LwoPolygons chunk to tag ids defined in the most recent LwoTags chunk. More...

`#include "lwoPolygonTags.h"`

Inheritance diagram for LwoPolygonTags:

## Public Member Functions
virtual TypeHandle | force_init_type ()
int | get_tag (int polygon_index) const
| Returns the tag associated with the given polygon index, or -1 if there is no tag associated.
virtual TypeHandle | get_type () const
bool | has_tag (int polygon_index) const
| Returns true if the map has a tag associated with the given polygon index, false otherwise.
virtual bool | read_iff (IffInputFile *in, size_t stop_at)
| Reads the data of the chunk in from the given input file, if possible.
virtual void | write (std::ostream &out, int indent_level=0) const
Public Member Functions inherited from IffChunk
IffId | get_id () const
| Returns the ID associated with this chunk.
virtual IffChunk * | make_new_chunk (IffInputFile *in, IffId id)
| Allocates and returns a new chunk of the appropriate type based on the given ID, according to the context given by this chunk itself.
virtual void | output (std::ostream &out) const
void | set_id (IffId id)
| Changes the ID associated with this chunk.
Public Member Functions inherited from TypedReferenceCount
| TypedReferenceCount (const TypedReferenceCount &copy)
void | operator= (const TypedReferenceCount &copy)
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer.
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer.
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type.
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly.
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type.
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object.
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise.
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack.
void | ref () const
| Explicitly increments the reference count.
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero.
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus.
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus.
virtual bool | unref () const
| Explicitly decrements the reference count.
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one.
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object.
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object.

## Static Public Member Functions
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from LwoChunk
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from IffChunk
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96.
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()

## Public Attributes
IffId | _tag_type
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count.

## Detailed Description

An association of polygons defined in the most recent LwoPolygons chunk to tag ids defined in the most recent LwoTags chunk.

This associated properties with the polygons, depending on the tag_type.

Definition at line 26 of file lwoPolygonTags.h.

## Member Function Documentation

## ◆ force_init_type()

virtual TypeHandle LwoPolygonTags::force_init_type | ( |  | ) |
| inline virtual

Reimplemented from LwoChunk.

Definition at line 45 of file lwoPolygonTags.h.

## ◆ get_class_type()

static TypeHandle LwoPolygonTags::get_class_type | ( |  | ) |
| inline static

Definition at line 46 of file lwoPolygonTags.h.

## ◆ get_tag()

int LwoPolygonTags::get_tag | ( | int | polygon_index | ) | const

Returns the tag associated with the given polygon index, or -1 if there is no tag associated.

Definition at line 36 of file lwoPolygonTags.cxx.

## ◆ get_type()

virtual TypeHandle LwoPolygonTags::get_type | ( |  | ) | const
| inline virtual

Reimplemented from LwoChunk.

Definition at line 42 of file lwoPolygonTags.h.

## ◆ has_tag()

bool LwoPolygonTags::has_tag | ( | int | polygon_index | ) | const

Returns true if the map has a tag associated with the given polygon index, false otherwise.

Definition at line 27 of file lwoPolygonTags.cxx.

## ◆ init_type()

static void LwoPolygonTags::init_type | ( |  | ) |
| inline static

Definition at line 49 of file lwoPolygonTags.h.

## ◆ read_iff()

bool LwoPolygonTags::read_iff | ( | IffInputFile * | in,
|  | size_t | stop_at )
| virtual

Reads the data of the chunk in from the given input file, if possible.

The ID and length of the chunk have already been read. stop_at is the byte position of the file to stop at (based on the current position at in->get_bytes_read()). Returns true on success, false otherwise.

Implements IffChunk.

Definition at line 53 of file lwoPolygonTags.cxx.

References IffInputFile::get_be_int16(), IffInputFile::get_bytes_read(), IffInputFile::get_id(), LwoInputFile::get_vx(), and IffInputFile::is_eof().

## ◆ write()

void LwoPolygonTags::write | ( | std::ostream & | out,
|  | int | indent_level = 0 ) const
| virtual

Reimplemented from IffChunk.

Definition at line 75 of file lwoPolygonTags.cxx.

## Member Data Documentation

## ◆ _tag_type

IffId LwoPolygonTags::_tag_type

Definition at line 31 of file lwoPolygonTags.h.

The documentation for this class was generated from the following files:

- pandatool/src/lwo/lwoPolygonTags.h
- pandatool/src/lwo/lwoPolygonTags.cxx